// demo.js

(function(ext) {
    var device = null;
    
	var levels = {
		HIGH:1,
		LOW:0
	};
    
	ext.resetAll = function(){};
    ext.i2cdisplay_sendDataToDisplay = function(){};
	ext.dht11h_readTemperature = function(){};
	ext.dht11h_readHumidity = function(){};
	ext.ds18b20_readTemperature = function(){}
	ext.ky032_isAvoided = function(){};
	ext.ky021_isEnabled = function(){};
	ext.ky027_isEnabled = function(){};
	ext.ax1838hs_readCode = function(){};
	ext.ax1838hs_mBlockRemoteKeyPressed = function(){};
	ext.rgbLed_enable = function(){};
	ext.runArduino = function(){};
	ext.ky008_enable = function() {};
	ext.k60Display_sendDataToDisplay = function(){};
    
	ext.digitalWrite = function(pin,level) {
        device.send([pin, levels[level]])
    };
	var _level = 0;

    function processData(bytes) {
        trace(bytes);
    }

    // Extension API interactions
    var potentialDevices = [];
    ext._deviceConnected = function(dev) {
        potentialDevices.push(dev);

        if (!device) {
            tryNextDevice();
        }
    }

    function tryNextDevice() {
        // If potentialDevices is empty, device will be undefined.
        // That will get us back here next time a device is connected.
        device = potentialDevices.shift();
        if (device) {
            device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
        }
    }

    function deviceOpened(dev) {
        if (!dev) {
            // Opening the port failed.
            tryNextDevice();
            return;
        }
        device.set_receive_handler('demo',function(data) {
            processData(data);
        });
    };

    ext._deviceRemoved = function(dev) {
        if(device != dev) return;
        device = null;
    };

    ext._shutdown = function() {
        if(device) device.close();
        device = null;
    };

    ext._getStatus = function() {
        if(!device) return {status: 1, msg: 'demo disconnected'};
        return {status: 2, msg: 'demo connected'};
    }

    var descriptor = {};
	ScratchExtensions.register('demo', descriptor, ext, {type: 'serial'});
})({});
