#include <Adafruit_GFX.h> 
#include <Adafruit_TFTLCD.h>
#include "k60display.h"

#define LCD_CS A3 
#define LCD_CD A2 
#define LCD_WR A1 
#define LCD_RD A0  
#define LCD_RESET A4

#define	BLACK   0x0000
#define	BLUE    0x001F
#define	RED     0xF800
#define	GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF

Adafruit_TFTLCD tft(LCD_CS, LCD_CD, LCD_WR, LCD_RD, LCD_RESET);
uint16_t identifier;

K60Display::K60Display(){
         
}

void K60Display::sendDataToDisplay(String message,int x,int y,String textColor,String backgroundColor,int size) {
  tft.reset();
  identifier=0x9341; 
  
  tft.begin(identifier);  

  if (backgroundColor=="BLACK") {
    tft.fillScreen(BLACK);
  }

  if (backgroundColor=="BLUE") {
    tft.fillScreen(BLUE);
  }

  if (backgroundColor=="RED") {
    tft.fillScreen(RED);
  }

  if (backgroundColor=="GREEN") {
    tft.fillScreen(GREEN);
  }

  if (backgroundColor=="CYAN") {
    tft.fillScreen(CYAN);
  }

  if (backgroundColor=="MAGENTA") {
    tft.fillScreen(MAGENTA);
  }

  if (backgroundColor=="YELLOW") {
    tft.fillScreen(YELLOW);
  }

  if (backgroundColor=="WHITE") {
    tft.fillScreen(WHITE);
  }


  if (textColor=="BLACK") {
    tft.setTextColor(BLACK);
  }

  if (textColor=="BLUE") {
    tft.setTextColor(BLUE);
  }

  if (textColor=="RED") {
    tft.setTextColor(RED);
  }

  if (textColor=="GREEN") {
    tft.setTextColor(GREEN);
  }

  if (textColor=="CYAN") {
    tft.setTextColor(CYAN);
  }

  if (textColor=="MAGENTA") {
    tft.setTextColor(MAGENTA);
  }

  if (textColor=="YELLOW") {
    tft.setTextColor(YELLOW);
  }

  if (textColor=="WHITE") {
    tft.setTextColor(WHITE);
  }
  
  
  tft.setCursor(x, y);
 
  tft.setTextSize(size);
  
  tft.println(message);
}

